/* RA4FHE APRS/GPRS Tracker. SIM900A module. */

#include <string.h>
#include <Arduino.h>
#include <SoftwareSerial.h>

SoftwareSerial mySerial(10, 11); // RX, TX Пины для подключения GSM модуля
char floatbuf[32];
String lat,lon,ns,ew;
String GPSStringbuf = "";
String GPSString = "";
int status,alti,sat; 
boolean stringComplete = false;

void setup()
{
  Serial.begin(9600);
  delay(100);
  GPSString.reserve(100);        
  mySerial.begin(9600);                    // Открываем порт 9600 bps
  delay(60000);                           
  mySerial.println("AT+IPR=9600");         // Инит скорости модуля 9600 bps
  delay(500);
  mySerial.println("AT+IFC=0,0");          // Управление потоком (без аппаратного и програмного контроля)
  delay(500);
  mySerial.println("AT+ICF=3,3");          // Режим передачи 8,N,1
  delay(500);
  mySerial.println("AT+CGATT=1");          // Включаем GPRS
  delay(500);
  mySerial.println("AT+CIPSHUT");          // Сброс всех TCP/IP соединений
  delay(500);
  mySerial.println("AT+CIPSTATUS");        // Проверка состояния инициализации IP стека
  delay(500);
  mySerial.println("AT+CIPMUX=0");         // Настраиваем соединение только с одним сервером
  delay(500);
  mySerial.println("AT+CSTT=\"internet.beeline.ru\",\"beeline\",\"beeline\"");  //APN, login, password провайдера
  delay(500);
  mySerial.println("AT+CIICR");            // Поднимаем GPRS соединение
  delay(6000);
  mySerial.println("AT+CIFSR");            // Получаем локальный IP адрес
  delay (1000);
 
}

void loop()
{
  while (Serial.available()) 
  {
    char inChar = (char)Serial.read(); 
    GPSString += inChar;
    if (inChar == '\n') {
      stringComplete = true;
    }
  }
  if (stringComplete) 
  {    
    if(GPSString.indexOf("$GPGGA") != -1)
    {

      //----------------Широта --------------------------------------------     
      GPSStringbuf = GPSString.substring(position(2), position(3) - 1); 
      lat = GPSStringbuf.substring(0,7);

      //----------------Направление координат NS---------------------------      
      GPSStringbuf = GPSString.substring(position(3), position(4) - 1); 
      ns = GPSStringbuf;

      //----------------Долгота -------------------------------------------                  
      GPSStringbuf = GPSString.substring(position(4), position(5) - 1); 
      lon = GPSStringbuf.substring(0,8);

      //----------------Направление координат EW---------------------------      
      GPSStringbuf = GPSString.substring(position(5), position(6) - 1); 
      ew = GPSStringbuf;

      //----------------Качество приёма GPS--------------------------------
      GPSStringbuf = GPSString.substring(position(6), position(7) - 1); 
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf)); 
      status = atoi(floatbuf);     

      //----------------Количество принимаемых спутников-------------------
      GPSStringbuf = GPSString.substring(position(7), position(8) - 1); 
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf)); 
      sat = atoi(floatbuf);  
      
      //----------------Высота в футтах------------------------------------
      GPSStringbuf = GPSString.substring(position(9), position(10) - 1); 
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf)); 
      alti = (atoi(floatbuf))*3.2808398950131;  

      if(status >=1) {
        mySerial.println("AT+CIPSTART=\"TCP\",\"russia.aprs2.net\",\"14580\"");      // Подключаемся к Российскому APRS серверу
        delay(5000);
        mySerial.println("AT+CIPSEND=150");     // Длина пакета 
        delay (2000);
        mySerial.println("user RA4FHE pass ****** vers GSM_GPRS 0.1 filter m/10"); // Логинемся на сервер
        mySerial.print("RA4FHE-2>APRS,TCPIP*:="); // Кидаем инфу о себе на сервер
        mySerial.print(lat);
        mySerial.print(ns);
        mySerial.print("/");
        mySerial.print(lon);
        mySerial.print(ew);
        mySerial.print("P");              // Иконка APRS
        mySerial.print("/A=000");
        mySerial.print(alti);
        mySerial.print(" SatView=");
        mySerial.print(sat);        
        mySerial.println(" APRS/GPRS Tracker"); // Комментарий 
        mySerial.println("#26"); //Концовка передачи на сервер (0x1A)
        delay (28000);
      }
    }

    GPSString = "";
    GPSStringbuf = "";
    stringComplete = false;
  }
}

int position(int number) 
{
  int i = 0;
  int position = 0;
  while(i < number)
  {
    position = GPSString.indexOf(",", position) + 1; 
    i++;
  }
  return position;
}
